package fr.velossity.sample.adapter.device.impl;

import fr.velossity.sample.adaptee.AdapteeDevice;
import fr.velossity.sample.device.Device;


/**
 * This class is a wrapper for all Adaptee devices.
 * @author C. Saint-Marcel
 * 
 */
public class DeviceAdapterImpl implements Device {

	/**
	 * The low device that we want to adapt.
	 */
	AdapteeDevice lowDevice;
	
	/**
	 * Constructor for iPOJO.
	 */
	public DeviceAdapterImpl(AdapteeDevice lowDevice) {
		this.lowDevice = lowDevice;
	}
	
	/**
	 * @see Device#getIdentifier()
	 * Realizes the service by delegation to the low device.
	 */
	public String getIdentifier() {
		return lowDevice.getUUID() + "_adapted";
	}

	/**
	 * @see Device#getType()
	 * Realizes the service by delegation to the low device.
	 */
	public String getType() {
		return lowDevice.getMetadata(AdapteeDevice.METADATA_MODEL) + " WRAPPER";
	}

	/**
	 * @see Device#getState()
	 * The device is always functional in our simple case.
	 */
	public String getState() {
		return DEVICE_STATE_FUNCTIONAL;
	}

}
